Package org.sqlite.core

## Class CoreResultSet

- java.lang.Object
- - org.sqlite.core.CoreResultSet

All Implemented Interfaces:
  `Codes`

Direct Known Subclasses:
  `JDBC3ResultSet`

    public abstract class CoreResultSet
    extends Object
    implements Codes

Implements a JDBC ResultSet.

### Field Summary

Fields
`boolean` `closeStmt`
`String[]` `cols` if null, the RS is closed()
`String[]` `colsMeta` same as cols, but used by Meta interface
`protected Map<String,​Integer>` `columnNameToIndex`
`boolean` `emptyResultSet` If the result set does not have any rows.
`protected int` `lastCol` last column accessed, for wasNull().
`protected int` `limitRows` 0 means no limit, must check against maxRows
`long` `maxRows` Maximum number of rows as set by a Statement
`protected boolean[][]` `meta`
`boolean` `open` If the result set is open.
`protected boolean` `pastLastRow`
`protected int` `row` number of current row, starts at 1 (0 is for before loading data)
`protected CoreStatement` `stmt`

### Fields inherited from interface org.sqlite.core.Codes

`SQLITE_ABORT, SQLITE_AUTH, SQLITE_BLOB, SQLITE_BUSY, SQLITE_CANTOPEN, SQLITE_CONSTRAINT, SQLITE_CORRUPT, SQLITE_DONE, SQLITE_EMPTY, SQLITE_ERROR, SQLITE_FLOAT, SQLITE_FULL, SQLITE_INTEGER, SQLITE_INTERNAL, SQLITE_INTERRUPT, SQLITE_IOERR, SQLITE_LOCKED, SQLITE_MISMATCH, SQLITE_MISUSE, SQLITE_NOLFS, SQLITE_NOMEM, SQLITE_NOTFOUND, SQLITE_NULL, SQLITE_OK, SQLITE_PERM, SQLITE_PROTOCOL, SQLITE_READONLY, SQLITE_ROW, SQLITE_SCHEMA, SQLITE_TEXT, SQLITE_TOOBIG`

### Constructor Summary

Constructors
`protected` `CoreResultSet​(CoreStatement stmt)` Default constructor for a given statement.

### Method Summary

All Methods Instance Methods Concrete Methods
`protected int` `addColumnIndexInCache​(String col, int index)`
`int` `checkCol​(int col)` Takes col in [1,x] form, returns in [0,x-1] form
`void` `checkMeta()`
`protected void` `checkOpen()`
`void` `close()`
`protected Integer` `findColumnIndexInCache​(String col)`
`protected SQLiteConnectionConfig` `getConnectionConfig()`
`protected DB` `getDatabase()`
`boolean` `isOpen()` Checks the status of the result set.
`protected int` `markCol​(int col)` Takes col in [1,x] form, marks it as last accessed and returns [0,x-1]

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### stmt

    protected final CoreStatement stmt

#### emptyResultSet

    public boolean emptyResultSet

If the result set does not have any rows.

#### open

    public boolean open

If the result set is open. Doesn't mean it has results.

#### maxRows

    public long maxRows

Maximum number of rows as set by a Statement

#### cols

    public String[] cols

if null, the RS is closed()

#### colsMeta

    public String[] colsMeta

same as cols, but used by Meta interface

#### meta

    protected boolean[][] meta

#### limitRows

    protected int limitRows

0 means no limit, must check against maxRows

#### row

    protected int row

number of current row, starts at 1 (0 is for before loading data)

#### pastLastRow

    protected boolean pastLastRow

#### lastCol

    protected int lastCol

last column accessed, for wasNull(). -1 if none

#### closeStmt

    public boolean closeStmt

#### columnNameToIndex

    protected Map<String,​Integer> columnNameToIndex

### Constructor Detail

#### CoreResultSet

    protected CoreResultSet​(CoreStatement stmt)

Default constructor for a given statement.

Parameters:
  `stmt` - The statement.

### Method Detail

#### getDatabase

    protected DB getDatabase()

#### getConnectionConfig

    protected SQLiteConnectionConfig getConnectionConfig()

#### isOpen

    public boolean isOpen()

Checks the status of the result set.

Returns:
  True if has results and can iterate them; false otherwise.

#### checkOpen

    protected void checkOpen()
                      throws SQLException

Throws:
  `SQLException` - if ResultSet is not open.

#### checkCol

    public int checkCol​(int col)
                 throws SQLException

Takes col in [1,x] form, returns in [0,x-1] form

Parameters:
  `col` -
Returns:
Throws:
  `SQLException`

#### markCol

    protected int markCol​(int col)
                   throws SQLException

Takes col in [1,x] form, marks it as last accessed and returns [0,x-1]

Parameters:
  `col` -
Returns:
Throws:
  `SQLException`

#### checkMeta

    public void checkMeta()
                   throws SQLException

Throws:
  `SQLException`

#### close

    public void close()
               throws SQLException

Throws:
  `SQLException`

#### findColumnIndexInCache

    protected Integer findColumnIndexInCache​(String col)

#### addColumnIndexInCache

    protected int addColumnIndexInCache​(String col,
                                        int index)